      SUBROUTINE SETUP0
      INCLUDE 'O8COMM.INC'
      INTEGER I,J,NUSER
      PARAMETER (NUSER= ... )
      DOUBLE PRECISION XST0(NUSER)
      DATA (XST0(I),I=1,NUSER) /
     F
     F       /
C   NAME IS IDENT OF THE EXAMPLE/USER AND CAN BE SET AT USERS WILL
C   THE FIRST CHARACTER MUST BE ALPHABETIC.  40 CHARACTERS MAXIMUM
       NAME='USEREXAMPLE'
C   X IS INITIAL GUESS AND ALSO HOLDS THE CURRENT SOLUTION
C   PROBLEM DIMENSION N=DIM(X), NH=DIM(H), NG=DIM(G)
      N=NUSER
      NH=..
      NG=..
      ANALYT=.
      COLD=.
      SILENT=.
      EPSDIF=
      PROU=10
      MEU=20
C   DEL0 AND TAU0: SEE BELOW
      DEL0=1.D0
      TAU0=1.D0
      DO I=1,N
	X(I)=XST0(I)
      ENDDO
C    GUNIT-ARRAY, SEE DONLP2DOC.TXT
      DO J=0,NH+NG
	GUNIT(1,J)=-1
	GUNIT(2,J)=0
	GUNIT(3,J)=0
      ENDDO
C  GCONST-ARRAY:
      DO J=...
        GCONST(J)=.TRUE.
C  IF THE J-TH FUNCTION IS AFFINE LINEAR
      ENDDO
      RETURN
      END

C     OBJECTIVE FUNCTION
      SUBROUTINE EF(X,FX)
      INCLUDE 'O8FUCO.INC'
      DOUBLE PRECISION X(*),FX
      ICF=ICF+1
      FX=...
      RETURN
      END
C     GRADIENT OF OBJECTIVE FUNCTION
      SUBROUTINE EGRADF(X,GRADF)
      INCLUDE 'O8FUCO.INC'
      DOUBLE PRECISION X(*),GRADF(*)
C     USER DECLARATIONS, IF ANY ,FOLLOW
      INTEGER J
      ICGF=ICGF+1
      DO           J=1,..
	GRADF(J)=....
      ENDDO
      RETURN
      END

C  COMPUTE THE I-TH EQUALITY CONSTAINT, VALUE IS HXI
      SUBROUTINE EH(I,X,HXI)
      INCLUDE 'O8FUCO.INC'
      DOUBLE PRECISION X(*),HXI
      INTEGER I
      CRES(I)=CRES(I)+1
      GOTO (100,200,300,......),I
  100 CONTINUE
      HXI=.........
      RETURN
  200 CONTINUE
      HXI=........
      RETURN
  300 CONTINUE
      HXI=........
      RETURN
 ..................
      END
C  COMPUTE THE GRADIENT OF THE I-TH EQUALITY CONSTRAINT
      SUBROUTINE EGRADH(I,X,GRADHI)
      INCLUDE 'O8FUCO.INC'
      DOUBLE PRECISION X(*),GRADHI(*)
      INTEGER I,J
      IF ( GUNIT(1,I) .NE. 1 ) CGRES(I)=CGRES(I)+1
      DO  J=1,NX
	GRADHI(J)=0.D0
      ENDDO
C
      GOTO(100,200,300,....),I
  100 CONTINUE
      DO J=1,..
	GRADHI(J)=..
      ENDDO
      RETURN
  200 CONTINUE
      DO J=1,...
	GRADHI(J)=
      ENDDO
      RETURN
  300 CONTINUE
      DO J=1,..
	GRADHI(J)=
      ENDDO
..................
      RETURN
      END

C COMPUTE THE I-TH INEQUALITY CONSTAINT, BOUNDS INCLUDED

      SUBROUTINE EG(I,X,GXI)
      INCLUDE 'O8FUCO.INC'
      DOUBLE PRECISION X(*),GXI
      INTEGER I
      IF ( GUNIT(1,I+NH) .EQ. -1 ) CRES(I+NH)=CRES(I+NH)+1
      GOTO (100,200,300,...), I
  100 CONTINUE
      GXI=..
      RETURN
  200 CONTINUE
      GXI=..
      RETURN
  300 CONTINUE
      GXI=..
      RETURN
      END
C COMPUTE THE GRADIENT OF THE I-TH INEQUALITY CONSTRAINT
C NOT NECESSARY FOR BOUNDS, BUT CONSTANT GRADIENTS MUST BE SET
C HERE E.G. USING DCOPY FROM A DATA-FIELD
      SUBROUTINE EGRADG(I,X,GRADGI)
      INCLUDE 'O8FUCO.INC'
      DOUBLE PRECISION X(*) ,GRADGI(*)
      INTEGER I,J
      IF ( GUNIT(1,I+NH) .NE. 1 ) CGRES(I+NH)=CGRES(I+NH)+1
      DO  J=1,NX
	GRADGI(J)=0.D0
      ENDDO
      GOTO(100,200,300,..),I
  100 CONTINUE
      DO J=1,..
	GRADGI(J)=..
      ENDDO
      RETURN
  200 CONTINUE
      DO J=1,..
	GRADGI(J)=.
      ENDDO
      RETURN
  300 CONTINUE
      DO J=1,..
	GRADGI(J)=..
      ENDDO
      RETURN
      END
      SUBROUTINE SETUP
      INCLUDE 'O8COMM.INC'
C     CHANGE TERMINATION CRITERION
      EPSX=..
C     CHANGE I/O-CONTROL
      TE0=.TRUE.
C*** NOW YOU GET FOR EVERY STEP A ONE-LINE-OUTPUT ON STDOUT
      ......
      RETURN
      END
